
## [p5.js community statement](http://p5js.org/community/)

p5.js is a community interested in exploring the creation of art and design with technology.

We are a community of, and in solidarity with, people from every gender identity and expression, sexual orientation, race, ethnicity, language, neuro-type, size, ability, class, religion, culture, subculture, political opinion, age, skill level, occupation, and background. We acknowledge that not everyone has the time, financial means, or capacity to actively participate, but we recognize and encourage involvement of all kinds. We facilitate and foster access and empowerment. We are all learners.

We like these hashtags: #noCodeSnobs (because we value community over efficiency), #newKidLove (because we all started somewhere), #unassumeCore (because we don't assume knowledge), and #BlackLivesMatter (because of course).

In practice:
* We are not code snobs. We do not assume knowledge or imply there are things that somebody should know.
* We insist on actively engaging with requests for feedback regardless of their complexity.
* We welcome newcomers and prioritize the education of others. We strive to approach all tasks with the enthusiasm of a newcomer. Because we believe that newcomers are just as valuable in this effort as experts.
* We consistently make the effort to actively recognize and validate multiple types of contributions.
* We are always willing to offer help or guidance.

In times of conflict:
* We listen.
* We clearly communicate while acknowledging other's feelings.
* We admit when we're wrong, apologize, and accept responsibility for our actions.
* We are continuously seeking to improve ourselves and our community.
* We keep our community respectful and open.
* We make everyone feel heard.
* We are mindful and kind in our interactions.

In the future:
* The future is now.


## p5.js Code of Conduct

* **Be mindful of your language.** Any of the following behavior is unacceptable: 
  * Offensive comments related to gender identity and expression, sexual orientation, race, ethnicity, language, neuro-type, size, ability, class, religion, culture, subculture, political opinion, age, skill level, occupation, or background
  * Threats of violence
  * Deliberate intimidation
  * Sexually explicit or violent material
  * Unwelcome sexual attention
  * Stalking or following
  * Or any other kinds of harassment

  Use your best judgement. If it will possibly make others uncomfortable, do not post it.

* **Be respectful.** Disagreement is not an opportunity to attack someone else's thoughts or opinions. Although views may differ, remember to approach every situation with patience and care. 
* **Be considerate.** Think about how your contribution will affect others in the community. 
* **Be open minded.** Embrace new people and new ideas. Our community is continually evolving and we welcome positive change.

If you believe someone is violating the code of conduct, we ask that you report it by emailing [hello@p5js.org](mailto:hello@p5js.org). Please include your name and a description of the incident, and we will get back to you ASAP.

Sometimes, participants violating the Code of Conduct are unaware that their behavior is harmful, and an open conversation clears things up to move forward. However, if a participant continues with the behavior, the p5.js team may take any action they deem appropriate, up to and including expulsion from all p5.js spaces and identification of the participant as a harasser to other p5.js members or the general public.
